//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   iX=0;
   iR=0;
   iE=0;
   iT=0;
   iA=0;
   iV=0;
   Label7->Caption=IntToStr(iX);
   Label8->Caption=IntToStr(iR);
   Label9->Caption=IntToStr(iE);
   Label10->Caption=IntToStr(iT);
   Label11->Caption=IntToStr(iA);
   Label12->Caption=IntToStr(iV);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnLoadXMLClick(TObject *Sender)
{
   OpenDialog1->InitialDir=ExtractFilePath(Application->ExeName);
   if(OpenDialog1->Execute())
   {
      if(FileExists(OpenDialog1->FileName))
      {
         XMLParser(OpenDialog1->FileName);
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::XMLParser(AnsiString szFileName)
{
   TreeView1->Items->Clear();

   try
   {
      XMLDocument1->LoadFromFile(szFileName);
   }
   catch(Exception &e)
   {
      ShowMessage(e.Message);
   }

   iX=0;
   iR=0;
   iE=0;
   iT=0;
   iA=0;
   iV=0;

   if(!XMLDocument1->IsEmptyDoc())
   {
      TTreeNode *TN=TreeView1->Items->Add(NULL, ExtractFileName(szFileName));
      TN->ImageIndex=0;
      TN->SelectedIndex=0;
      iX=1;

      _di_IXMLNode XN=XMLDocument1->DocumentElement;
      XMLTree(TN, XN, 1);
   }
   TreeView1->FullExpand();

   Label7->Caption=IntToStr(iX);
   Label8->Caption=IntToStr(iR);
   Label9->Caption=IntToStr(iE);
   Label10->Caption=IntToStr(iT);
   Label11->Caption=IntToStr(iA);
   Label12->Caption=IntToStr(iV);
}
void __fastcall TForm1::XMLTree(TTreeNode *TN, _di_IXMLNode XN, int iIndex)
{
   TTreeNode *TN1=NULL;
   switch(iIndex)
   {
      case 0:
         TN1=TN;
         break;
      case 1:
         TN1=TreeView1->Items->AddChild(TN, XN->NodeName);
         TN1->ImageIndex=1;
         TN1->SelectedIndex=1;
         iR=1;
         break;
      case 2:
         TN1=TreeView1->Items->AddChild(TN, XN->NodeName);
         TN1->ImageIndex=2;
         TN1->SelectedIndex=2;
         iE++;
         break;
      case 3:
         TN1=TreeView1->Items->AddChild(TN, XN->NodeValue);
         TN1->ImageIndex=3;
         TN1->SelectedIndex=3;
         iT++;
         return;
      case 4:
         TN1=TreeView1->Items->AddChild(TN, XN->NodeName);
         TN1->ImageIndex=4;
         TN1->SelectedIndex=4;
         iA++;
         XMLTree(TN1, XN, 5);
         return;
      case 5:
         TN1=TreeView1->Items->AddChild(TN, XN->NodeValue);
         TN1->ImageIndex=5;
         TN1->SelectedIndex=5;
         iV++;
         return;
   }
   if(XN->HasChildNodes)
   {
      for(int i=0; i<XN->ChildNodes->Count; i++)
      {
         TTreeNode *TN2=NULL;
         _di_IXMLNode XN1=XN->ChildNodes->Nodes[i];
         _di_IXMLNodeList XNL=XN1->GetAttributeNodes();
         if(XNL->Count>0)
         {
            TN2=TreeView1->Items->AddChild(TN1, XN1->NodeName);
            TN2->ImageIndex=2;
            TN2->SelectedIndex=2;
            iE++;
            for(int j=0; j<XNL->Count; j++)
            {
               XMLTree(TN2, XNL->Nodes[j], 4);
            }
            XMLTree(TN2, XN1, 0);
         }
         else
         {
            if(XN1->IsTextElement)
            {
               TN2=TreeView1->Items->AddChild(TN1, XN1->NodeName);
               TN2->ImageIndex=2;
               TN2->SelectedIndex=2;
               iE++;
               XMLTree(TN2, XN1, 3);
            }
            else
            {
               XMLTree(TN1, XN1, 2);
            }
         }
      }
   }
}
